RHCE8学习过程(十一)重定向和文件的查询

十一、重定向和文件的查询

11.1、文件描述符

用户通过操作系统处理信息的过程中,使用的交互设备文件(键盘,鼠标,显示器)

11.1.1 输入输出标准说明

STDIN 标准输入 默认的设备是键盘
STDOUT 标准输出 默认的设备是显示器 文件编号为:1 ,也可以重定向到文件
STDERR 标准错误 默认的设备是显示器 文件编号为:2 ,也可以重定向到文件
在这里插入图片描述

例:查看一个进程打开了哪些文件
语法: ll /proc/进程 ID/fd

[root@Hengji ~]# vim /etc/passwd

[root@Hengji ~]# ps -axu | grep passwd
root        3782  0.0  0.1  48744  8596 pts/0    S+   17:52   0:00 vim /etc/passwd
root        3824  0.0  0.0  12320  1048 pts/1    S+   17:53   0:00 grep --color=auto passwd
[root@Hengji ~]# ll /proc/3782/fd            #查看打开的文件
总用量 0
lrwx------. 1 root root 64 10月 13 17:53 0 -> /dev/pts/0
lrwx------. 1 root root 64 10月 13 17:53 1 -> /dev/pts/0
lrwx------. 1 root root 64 10月 13 17:53 2 -> /dev/pts/0
lr-x------. 1 root root 64 10月 13 17:53 3 -> /var/lib/sss/mc/passwd
lrwx------. 1 root root 64 10月 13 17:53 4 -> 'socket:[63314]'
lrwx------. 1 root root 64 10月 13 17:53 6 -> /etc/.passwd.swp

注: 这些 0,1,2,4 就是文件的描述符。一个进程启动时,都会打开 3 个文件:标准输入、标准输出和标准出错处理。这 3 个文件分别对应文件描述符为 0、1 和 2 也就是宏替换STDIN_FILENO、STDOUT_FILENO 和 STDERR_FILENO。

/proc/进程 ID/fd :这个 fd 目录下,专门存文件描述符

注:对文件描述符的操作就是对文件本身的操作。 我可以直接通过操作文件描述来修改文件。

例:查看和临时设置一个进程最多可以打开几个文件
即:一个进程可以打开的文件描述符限制

[root@Hengji ~]# ulimit -n        #查看一个进程最多可以同时打开的文件数
1024
[root@Hengji ~]# ulimit -n 2048     #修改一个进程最多可以同时打开的文件数为 2048
[root@Hengji ~]# ulimit -n
2048

永久修改,后续会讲。

11.2、重定向的含义-管道的使用-tee 命令

11.2.1 输出重定向

定义:将命令的正常输出结果保存到指定的文件中,而不是直接显示在显示器的屏幕上

重定向输出使用”>” “>>” 操作符号

语法: > 文件名 #表示将标准输出的内容,写到后面的文件中,如果此文件名已经存在,将会覆盖原文件中的内容

>> 文件名 #表示将标准输出的内容,追加到后面的文件中。若重定向的输出的文件不存在,则会新建该文件

例:查看当前主机的 CPU 的类型
保存到 cpu.txt 文件中(而不是直接显示到屏幕上)

[root@Hengji ~]# cat /proc/cpuinfo > cpu.txt
[root@Hengji ~]# cat cpu.txt 
processor	: 0
vendor_id	: GenuineIntel
cpu family	: 6
model		: 158
model name	: Intel(R) Core(TM) i5-8400 CPU @ 2.80GHz
...

例:将内核的版本信息追加到 cpu.txt

[root@Hengji ~]# uname -a >> cpu.txt

例:清空一个文件

[root@Hengji ~]# > cpu.txt 
[root@Hengji ~]# cat cpu.txt 

11.2.2 输入重定向

将命令中接收输入的途径由默认的键盘改为其他文件。而不是等待从键盘输入

[root@Hengji ~]# grep root /etc/passwd
root:x:0:0:root:/root:/bin/bash
operator:x:11:0:operator:/root:/sbin/nologin
[root@Hengji ~]# grep root < /etc/passwd
root:x:0:0:root:/root:/bin/bash
operator:x:11:0:operator:/root:/sbin/nologin

mysql 中数据导入

[root@Hengji ~]# mysql -uroot -p123456 < hengji.sql     #将 hengji.sql 导入mysql 数据库中

11.2.3 EOF

EOF 本意是 End Of File,表明到了文件末尾。”EOF“通常与”<<“结合使用,“<<EOF“表示后续的输入作为子命令或子 shell 的输入,直到遇到”EOF“,再次返回到主调 shell,可将其理解为分界符(delimiter)。既然是分界符,那么形式自然不是固定的,这里可以将”EOF“可以进行自定义,但是前后的”EOF“必须成对出现且不能和 shell 命令冲突。
例:以 << EOF 开始,以 EOF 结尾

[root@Hengji ~]# cat > a.txt <<EOF
> dfsd
> sdfs
> sdf
> dfs
> EOF
[root@Hengji ~]# cat a.txt 
dfsd
sdfs
sdf
dfs

例:以 ccc 作为分界符

[root@Hengji ~]# cat > a.txt <<ccc
> eof
> EOF
> ccc
[root@Hengji ~]# cat a.txt 
eof
EOF

在脚本中我们可以通过重定向输入来打印消息菜单
在使用的时候需要在”<< “右边跟一对终止符。终止符是可以自定义

[root@Hengji ~]# vim eof.sh           #写入以下内容 
[root@Hengji ~]# cat eof.sh 
#!/bin/bash
cat <<efo
========================
1.mysql
2.httpd
3.oracle
=======================
efo
[root@Hengji ~]# chmod +x eof.sh 
[root@Hengji ~]# ./eof.sh             #查看效果
========================
1.mysql
2.httpd
3.oracle
=======================

11.2.4 错误重定向

将命令执行过程中出现的错误信息 (选项或参数错误) 保存到指定的文件,而不是直接显示到显示器
作用:错误信息保存到文件

操作符: 错误重定向符号:2>
2 指的是标准错误输出的文件描述符

在实际应用中,错误重定向可以用来收集执行的错误信息.为排错提供依据;对于 shell 脚本还可以将无关紧要的错误信息重定向到空文件/dev/null 中,以保持脚本输出的简洁

例:将错误显示的内容和正确显示的内容分开

[root@Hengji ~]# ls /etc/passwd xxx
ls: 无法访问'xxx': 没有那个文件或目录
/etc/passwd
[root@Hengji ~]# ls /etc/passwd xxx > a.txt
ls: 无法访问'xxx': 没有那个文件或目录
[root@Hengji ~]# cat a.txt 
/etc/passwd
[root@Hengji ~]# ls /etc/passwd xxx 2> a.txt
/etc/passwd
[root@Hengji ~]# cat a.txt 
ls: 无法访问'xxx': 没有那个文件或目录

注:使用 2> 操作符时,会像使用 > 一样覆盖目标文件的内容,若追加而不覆盖文件的内容即可使用2>> 操作符

11.2.5 null 黑洞和 zero 空文件

1、把/dev/null 看作"黑洞",所有写入它的内容都会永远丢失。
而尝试从它那儿读取内容则什么也读不到。
然而 /dev/null 对命令行和脚本都非常的有用。

[root@Hengji ~]# echo aaaa > /dev/null 
[root@Hengji ~]# cat /dev/null                #什么信息也看不到

2、/dev/zero 在类 UNIX 操作系统中, /dev/zero 是一个特殊的文件,当你读它的时候,它会提供无限的空字符(NULL, ASCII NUL, 0x00)。典型用法是用它来产生一个特定大小的空白文件。

参数:
if 代表输入文件。如果不指定 if,默认就会从 stdin 中读取输入。
of 代表输出文件。如果不指定 of,默认就会将 stdout 作为默认输出。
bs 代表字节为单位的块大小。
count 代表被复制的块数。

例:使用 dd 命令产生一个 50M 的文件

[root@Hengji ~]# dd if=/dev/zero of=b.txt bs=1M count=50
记录了50+0 的读入
记录了50+0 的写出
52428800 bytes (52 MB, 50 MiB) copied, 0.0155989 s, 3.4 GB/s
[root@Hengji ~]# du -sh b.txt 
50M	b.txt
[root@Hengji ~]# cat !$
cat b.txt
[root@Hengji ~]# cat b.txt
[root@Hengji ~]# ls /tmp xxxx >ok.txt 2> err.txt          #正确的内容写入一个文件,错误的写入一个文件

11.2.6 &>和>&符号

&表示等同于的意思
例 1:把正确和错误的消息输入到相同的位置

1>&2 把标准输出重定向到标准错误
2>&1 把标准错误重定向到标准输出

例 2:把正确和错误的消息输入到相同的位置

[root@Hengji ~]# ls /tmp xxxx >1.txt 2>&1
[root@Hengji ~]# ls /tmp xxxx 2>2.txt 1>&2

工作中 shell 脚本中的 >/dev/null 2>&1 是什么意思?

[root@Hengji ~]# cat /etc/passwd >/dev/null 2>&1

注:将标准输出和错误输出全部重定向到/dev/null 中,也就是将产生的所有信息丢弃。

11.2.7 管道 | 的使用

语法:command-a | command-b | command-c | …
注意:

  • 1、管道命令只处理前一个命令正确输出,不处理错误输出
  • 2、管道右边的命令,必须能够接收标准输入的数据流命令才行
  • 3、管道符可以把两条命令连起来,它可以链接多个命令使用
[root@Hengji ~]# ps -axu | grep sshd
root        1030  0.0  0.0  92968  6872 ?        Ss   15:57   0:00 /usr/sbin/sshd -D
root        4829  0.0  0.0  12320  1076 pts/0    S+   18:28   0:00 grep --color=auto sshd

11.2.8 tee 命令

功能:读取标准输入的数据,并将其内容输出成文件。
语法:tee [-a][–help][–version][文件…]

参数:
-a, --append 内容追加到给定的文件而非覆盖
–help  在线帮助
tee 指令会从标准输入设备读取数据,将其内容输出到标准输出设备,同时保存成文件。

将磁盘使用的信息写入文件

[root@Hengji ~]# df -h | tee disk.log
文件系统        容量  已用  可用 已用% 挂载点
devtmpfs        3.9G     0  3.9G    0% /dev
tmpfs           3.9G     0  3.9G    0% /dev/shm
tmpfs           3.9G   10M  3.9G    1% /run
tmpfs           3.9G     0  3.9G    0% /sys/fs/cgroup
/dev/sda2        50G  5.2G   45G   11% /
/dev/sda1       976M  290M  620M   32% /boot
tmpfs           795M  1.2M  794M    1% /run/user/42
tmpfs           795M  4.6M  790M    1% /run/user/0
/dev/sr0        7.7G  7.7G     0  100% /run/media/root/CentOS-8-2-2004-x86_64-dvd

将文件系统使用的信息追加到文件

[root@Hengji ~]# df -h | tee -a disk.log
文件系统        容量  已用  可用 已用% 挂载点
devtmpfs        3.9G     0  3.9G    0% /dev
tmpfs           3.9G     0  3.9G    0% /dev/shm
tmpfs           3.9G   10M  3.9G    1% /run
tmpfs           3.9G     0  3.9G    0% /sys/fs/cgroup
/dev/sda2        50G  5.2G   45G   11% /
/dev/sda1       976M  290M  620M   32% /boot
tmpfs           795M  1.2M  794M    1% /run/user/42
tmpfs           795M  4.6M  790M    1% /run/user/0
/dev/sr0        7.7G  7.7G     0  100% /run/media/root/CentOS-8-2-2004-x86_64-dvd

注: 可以使用来记录日志

11.3、文件查找常用命令

11.3.1 which-whereis-locate-grep find 命令使用

查找文件一般有以下几个命令:
which 查看可执行文件的位置
whereis 查看可执行文件的位置及相关文件
locate 配合数据库缓存,快速查看文件位置
grep 过滤匹配,它是一个文件搜索工具
find 查找相关文件

举例:

[root@Hengji ~]# which cd
/usr/bin/cd
[root@Hengji ~]# whereis cd
cd: /usr/bin/cd /usr/share/man/man1/cd.1.gz /usr/share/man/man1p/cd.1p.gz
[root@Hengji ~]# whereis ls
ls: /usr/bin/ls /usr/share/man/man1/ls.1.gz /usr/share/man/man1p/ls.1p.gz

locate

locate 命令和 find -name 功能差不多,是它的另外一种写法,但是这个要比 find 搜索快的多,因为 find 命令查找的是具体目录文件,而 locate 它搜索的是一个数据库==/var/lib/mlocate/mlocate.db==,这个数据库中存有本地所有的文件信息;这个数据库是 Linux 自动创建并每天自动更新维护。相关的配置信息在==/etc/updatedb.conf==,查看定时任务信息

[root@Hengji ~]# touch /opt/hengji.txt
[root@Hengji ~]# locate hengji.txt
locate: 无法执行 stat () `/var/lib/mlocate/mlocate.db': 没有那个文件或目录
[root@Hengji ~]# updatedb
[root@Hengji ~]# locate hengji.txt
/opt/hengji.txt

grep 查找使用

作用:过滤,它能够使用正则表达式来搜索文本,并把结果打印出来

参数:

  • -v 取反
  • -i 忽略大小写
  • ^# 以#开头
  • #$ 以#结尾
  • ^$ 空行
  • -n 对过滤的内容加上行号
  • | 或者的意思
[root@Hengji ~]# ps -aux | grep sshd | grep -v grep
root        1024  0.0  0.0  92968  7112 ?        Ss   10:27   0:00 /usr/sbin/sshd -D
[root@Hengji ~]# grep bash$ /etc/passwd
root:x:0:0:root:/root:/bin/bash
hengji:x:1000:1000:Hengji:/home/hengji:/bin/bash
[root@Hengji ~]# grep "nologin\|root" /etc/passwd | wc -l          #查看包括 nologin 或 root 的行
44
[root@Hengji ~]# egrep "nologin|root" /etc/passwd | wc -l 
44

egrep 是 grep 加强版本

11.3.3 find 命令使用

格式:find pathname -options [-print]
对应:命令字 路径名称 选项 输出

参数:
pathname: find 命令所查找的目录路径,不输入代表当前目录例如用 . 来表示当前目录,用 / 来表示系统根目录。

find 命令选项:

  1. -name 按照文件名查找文件。 “名称”
  2. -perm 按照文件权限来查找文件。666 777 等
  3. -user 按照文件属主来查找文件
  4. -group 按照文件所属的组来查找文件
  5. -mtime -n / +n 按照文件的更改时间来查找文件,
    -n表示文件更改时间距现在 n 天以内
    +n 表示文件更改时间距现在 n 天以前
  6. -type 查找某一类型的文件
    b - 块设备文件
    d - 目录
    c - 字符设备文件
    p - 管道文件
    l- 符号链接文件
    f - 普通文件
  7. -size n 查找符合指定的文件大小的文件
  8. -exec 对匹配的文件执行该参数所给出的其他 linux 命令, 相应命令的形式为’ 命令 {} ;,注意{ }和 \;之间的空格,{}代表查到的内容

例:查看当前目录下所有的 TXT 格式的文件

[root@Hengji ~]# find . -name "*.txt"    #都是上一章创建的txt
./.cache/tracker/db-version.txt
./.cache/tracker/db-locale.txt
./.cache/tracker/parser-version.txt
./.cache/tracker/locale-for-miner-apps.txt
./.cache/tracker/last-crawl.txt
./.cache/tracker/first-index.txt
./cpu.txt
./a.txt
./b.txt
./ok.txt
./err.txt
./1.txt
./2.txt

例:按照更改时间或访问时间等查找文件
如果希望按照更改时间来查找文件,可以使用 mtime,atime 或 ctime 选项

  • mtime: 文件最后一次修改的时间
  • atime: 最后一次访问时间
  • ctime: 文件的最后一次变化时间,也就是修改时间

例 :希望在 root 目录下查找更改时间在 1 天以内,被黑客修改的文件

[root@Hengji ~]# find /root/ -mtime -1

对查找内容执行相应命令

-exec 这个选项参数后面可以跟自定义的 SHELL 命令,格式如下:

在这里插入图片描述
例子:

[root@Hengji ~]# touch {1,2,3}.back
[root@Hengji ~]# find . -name "*.back" -exec ls -l {} \;
-rw-r--r--. 1 root root 0 10月 15 11:05 ./1.back
-rw-r--r--. 1 root root 0 10月 15 11:05 ./2.back
-rw-r--r--. 1 root root 0 10月 15 11:05 ./3.back
[root@Hengji ~]# find . -name "*.back" -exec mv {} /opt \;
[root@Hengji ~]# ls /opt/
1.back  2.back  3.back  hengji.txt

例:把查找到的文件复制到一个指定的目录

[root@xuegod63 mnt]# find /root -name "*.txt" -exec cp {} /opt \

xargs 和 find 命令结合 复制文件 -i 表示 find 传递给 xargs 的结果 由{}来代替 (了解)

[root@Hengji ~]# rm -rf /opt/*
[root@Hengji ~]# find . -name "*.txt" | xargs -i cp {} /opt
[root@Hengji ~]# ls /opt/
1.txt  b.txt          db-version.txt   last-crawl.txt             parser-version.txt
2.txt  cpu.txt        err.txt          locale-for-miner-apps.txt
a.txt  db-locale.txt  first-index.txt  ok.txt

例:查找多个类型文件
比较符的使用:
-a:and 并且
-o:or 或者
+:超过
-:低于

[root@Hengji ~]# touch a.pdf back.sh
[root@Hengji ~]# find . -name "*.sh" -o -name "*.pdf"
./eof.sh
./a.pdf
./back.sh
[root@Hengji ~]# find /etc -size +20k -a -size -50k | wc -l
14
[root@Hengji ~]# find /etc -size +20k | wc -l
37

按权限查找:-perm

[root@Hengji ~]# find /bin/ -perm 755 # 等于 0755 权限的文件或目录
[root@Hengji ~]# find /bin/ -perm -644 #-perm -644 至少有 644 权限的文件或目录

例:查看系统中权限至少为 777 的文件或目录
创建一些测试文件:

[root@Hengji ~]# mkdir ccc
[root@Hengji ~]# chmod 777 ccc
[root@Hengji ~]# mkdir test
[root@Hengji ~]# chmod 1777 test
[root@Hengji ~]# touch b.sh
[root@Hengji ~]# chmod 4777 b.sh

查找:

[root@Hengji ~]# find /root/ -perm 777
/root/ccc
[root@Hengji ~]# find /root/ -perm 1777
/root/test
[root@Hengji ~]# find /root/ -perm 4777
/root/b.sh

把系统中权限不低于 777 的危险目录查找出来

[root@Hengji ~]# find /root/ -perm -777
/root/ccc
/root/test
/root/b.sh

把系统中权限不低于 777 的危险文件查找出来

[root@Hengji ~]# find / -type f -perm -777
find: ‘/proc/3681/task/3681/fdinfo/5’: 没有那个文件或目录
find: ‘/proc/3681/fdinfo/6’: 没有那个文件或目录
/root/b.sh

例:查找的目录深度:
-maxdepth 1 #只查找目录第一层的文件和目录
如:查找/bin 目录下权限等于 644 的文件

[root@Hengji ~]# find /etc/ -maxdepth 1 -perm 644 | more
[root@Hengji ~]# find /bin/ -maxdepth 1 -perm 755      #/bin 后面要有/
[root@Hengji ~]# find /bin -maxdepth 1 -perm 755
#这个命令无法满足我们的需求

例:查找系统中所有属于用户 hengji 的文件,并把这个文件,放到/root/findresults 目录下
注意:/root/findresults 这个需要提前创建好。

[root@Hengji ~]# mkdir /root/findresults
[root@Hengji ~]# find / -user hengji -exec cp -a {} /root/findresults/ \;          #参数: -a #复制时,保留原来文件的所有属性
find: ‘/proc/3904/task/3904/fd/6’: 没有那个文件或目录
find: ‘/proc/3904/task/3904/fdinfo/6’: 没有那个文件或目录
find: ‘/proc/3904/fd/7’: 没有那个文件或目录
find: ‘/proc/3904/fdinfo/7’: 没有那个文件或目录

cp: 无法以目录"/home/hengji" 来覆盖非目录"/root/findresults/hengji"
同一个目录下,可以创建文件 user1 和文件夹 hengji 吗?同一个目录下创建的文件名和目录名一样吗?
答:不可以

解决:

[root@Hengji ~]# find / -user hengji    #发现
[root@Hengji ~]# ll /var/spool/mail/hengji       #查看这个文件
-rw-rw----. 1 hengji mail 0 9月   3 10:24 /var/spool/mail/hengji
[root@Hengji ~]# ll /home/hengji

发现/var/spool/mail/hengji 和/home/hengji 的名字是一样的。 而两者都要复制到/root/findresults/下,先复制了/var/spool/mail/hengji,所以/home/hengji 就不能复制了。

[root@Hengji ~]# mv /var/spool/mail/hengji /var/spool/mail/hengji.mail
[root@Hengji ~]# rm -rf /root/findresults/*
[root@Hengji ~]# find / -user new -exec cp -a {} /root/findresults/ \;
[root@Hengji ~]# mv /var/spool/mail/Hengji.mail /var/spool/mail/Hengji
#再修改过来

11.4、命令判断

11.4.1 常用的三个特殊符号

; 分号 不考虑指令的相关性,连续执行

分号; 不保证命令全部执行成功的

[root@Hengji ~]# sync ; shutdown -F
Shutdown scheduled for Thu 2020-10-15 15:03:45 CST, use 'shutdown -c' to cancel.

&&:逻辑与

它是只有在前面的命令执行成功后,后面的命令才会去执行
例:如果/opt 目录存在,则在/opt 下面新建一个文件 a.txt

[root@Hengji ~]# cd /opt/ && touch /opt/a.txt && ls
1.txt  b.txt          db-version.txt   last-crawl.txt             parser-version.txt
2.txt  cpu.txt        err.txt          locale-for-miner-apps.txt
a.txt  db-locale.txt  first-index.txt  ok.txt

例:源码编译经典使用方法

[root@Hengji ~]# ./configure && make -j 4 && make install

||:逻辑或

如果前面的命令执行成功,后面的命令就不去执行了;或者如果前面的执行不成功,才会去执行后面的命令

[root@Hengji ~]# ls xxx || cd /mnt/
ls: 无法访问'xxx': 没有那个文件或目录
[root@Hengji mnt]# pwd
/mnt
[root@Hengji mnt]# ls /etc/passwd || cd /etc/
/etc/passwd
[root@Hengji mnt]# pwd
/mnt

总结:
命令情况 说明
命令 1 && 命令 2:如果命令 1 执行,且执行正确($? = 0),然后执行命令 2

如果命令 1 执行完成,但是执行错误($? ≠0),那么后面的命令是不会执行的

命令 1 || 命令 2:如果命令 1 执行,且执行正确($? = 0),那么命令 2 不执行

如果命令 1 执行,但执行错误($? ≠ 0),那么命令 2 执行

运算顺序:LINUX 执行命令,是从左到右一个一个执行,从上到下执行

[root@Hengji mnt]# cd /opt/back || mkdir /opt/back && touch /opt/back/back.tar && ls /opt/back
bash: cd: /opt/back: 没有那个文件或目录
back.tar
[root@Hengji mnt]# ll /opt/back/
总用量 0
-rw-r--r--. 1 root root 0 10月 15 15:11 back.tar
©️2020 CSDN 皮肤主题: 护眼 设计师:闪电赇 返回首页